import type { Knex } from 'knex';
import { Model } from 'objection';
import { PGDispatcher } from './dispatcher';
import type { ExLogger } from './types';
export interface CoreDBDispatcherOptions {
    healthcheckInterval?: number;
    healthcheckTimeout?: number;
    suppressStatusLogs?: boolean;
    beforeTerminate?: () => Promise<void>;
}
export interface CoreDBConstructorArgs {
    connectionString: string;
    dispatcherOptions?: CoreDBDispatcherOptions;
    knexOptions?: Knex.Config;
    logger?: ExLogger;
}
declare class BaseModel extends Model {
    static set db(value: PGDispatcher);
    static get primary(): InstanceType<typeof PGDispatcher>['primary'];
    get primary(): InstanceType<typeof PGDispatcher>['primary'];
    static get replica(): InstanceType<typeof PGDispatcher>['replica'];
    get replica(): InstanceType<typeof PGDispatcher>['replica'];
}
export declare function getModel(): typeof BaseModel;
export declare function initDB({ connectionString, dispatcherOptions, knexOptions, logger, }: CoreDBConstructorArgs): {
    db: PGDispatcher;
    CoreBaseModel: typeof BaseModel;
    helpers: {
        clearDatabase: () => Promise<void>;
        rollbackDatabase: () => Promise<void>;
        migrateDatabase: () => Promise<void>;
        prepareDatabase: () => Promise<void>;
    };
};
export {};
